﻿using System.Data;
using System.Windows;

namespace FieldLayouts
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private enum eLayout
        {
            LAYOUT1,
            LAYOUT2,
            MASTERFIELD
        }

        private DataSet mclsDataSet;
        private DataTable mclsDTColSets;

        private bool mblnFirstLayoutIsSet = false;

        public MainWindow()
        {
            InitializeComponent();

            mclsDataSet = new DataSet();
            mclsDTColSets = new DataTable("Settings");
            mclsDataSet.Tables.Add(mclsDTColSets);

            mclsDTColSets.Columns.Add(new DataColumn("ID", typeof(System.Int32)));
            mclsDTColSets.Columns.Add(new DataColumn("Description", typeof(System.String)));
            mclsDTColSets.Columns.Add(new DataColumn("Rounding", typeof(System.Double)));
            mclsDTColSets.Columns.Add(new DataColumn("B", typeof(System.Boolean)));
            mclsDTColSets.Columns.Add(new DataColumn("Layout", typeof(eLayout)));

            xamDataGrid1.DataSource = mclsDataSet.Tables["Settings"].DefaultView;

            DataRow clsRow = mclsDTColSets.NewRow();

            clsRow["ID"] = 1;
            clsRow["Description"] = "Line One";
            clsRow["Rounding"] = 0.001;
            clsRow["B"] = true;
            clsRow["Layout"] = eLayout.MASTERFIELD;

            mclsDTColSets.Rows.Add(clsRow);

            clsRow = mclsDTColSets.NewRow();

            clsRow["ID"] = 2;
            clsRow["Description"] = "Line Two";
            clsRow["Rounding"] = 0.002;
            clsRow["B"] = true;
            clsRow["Layout"] = eLayout.LAYOUT2;

            mclsDTColSets.Rows.Add(clsRow);

            clsRow = mclsDTColSets.NewRow();
            
            clsRow["ID"] = 3;
            clsRow["Description"] = "Line Three";
            clsRow["Rounding"] = 0.003;
            clsRow["B"] = false;
            clsRow["Layout"] = eLayout.LAYOUT1;

            mclsDTColSets.Rows.Add(clsRow);

            clsRow = mclsDTColSets.NewRow();

            clsRow["ID"] = 4;
            clsRow["Description"] = "Line Four";
            clsRow["Rounding"] = 0.004;
            clsRow["B"] = false;
            clsRow["Layout"] = eLayout.LAYOUT2;

            mclsDTColSets.Rows.Add(clsRow);
        }

        private void xamDataGrid1_AssigningFieldLayoutToItem(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e)
        {
            DataRowView drView = (DataRowView)e.Item;
            eLayout layoutType = (eLayout)drView.Row["Layout"];

            switch (layoutType)
            {
                case eLayout.LAYOUT1: e.FieldLayout = xamDataGrid1.FieldLayouts["Layout1"]; break;
                case eLayout.LAYOUT2: e.FieldLayout = xamDataGrid1.FieldLayouts["Layout2"]; break;
                case eLayout.MASTERFIELD: e.FieldLayout = xamDataGrid1.FieldLayouts["MasterField"]; break;
            }

            //// I don't know, how i should solve this.
            

            //// TRY 1:
            //// You said, i should set the "LabelLocation" of all but the first to Hidden:
            //// but if the first Layout is used a second time at the third record, it's going to be overwritten.

            //if (!mblnFirstLayoutIsSet)
            //    mblnFirstLayoutIsSet = true;
            //else
            //    e.FieldLayout.Settings.LabelLocation = Infragistics.Windows.DataPresenter.LabelLocation.Hidden;


            //// TRY 2:
            //// but if i don't set the first Layout to Hidden then everytime, the first layout is assigned, 
            //// i get a new Header
           
            //if (layoutType == eLayout.LAYOUT2)
            //    e.FieldLayout.Settings.LabelLocation = Infragistics.Windows.DataPresenter.LabelLocation.Hidden;


            //// Furthermore: I do NOT want to sort the DataGrid to see all same FieldLayouts together!!!
            //// How can i disable the header click action?
            //// Actually i do not want the layout1-Header on top. I want the layout2-header on top. 
            //// (Because i want the Description-Header-Text to overlap both Fields (Description and Rounding))
            //// Probably would exist an easy way to create my user-defined header, but i don't know how.


            //// I hope i explained it good :) Thanks for your help.
        }
    }
}
